# Validation and/or decryption SignedDirectEncryptedPseudonym with diversifier fails - Alternate Flow

tags: signed-direct-encrypted-pseudonym, pseudonym, diversifier, alternate-flow, @bsnkeiddo-5079@

* Load dataset from "/v1/signed-direct-encrypted-pseudonym/alternate_flows_diversifier.yaml"
* Target default endpoint "/signed-direct-encrypted-pseudonym"

### Given

A SignedDirectEncryptedPseudonym with diversifier, SP-key, schemekey and closingkey is provided as input for the decryption component

### When

The SignedDirectEncryptedPseudonym and/or keys are invalid or the combination does not match

### Then

No Pseudonym is returned in the response message with corresponding error status

### Description

Alternate flows
-- EP/DEP with diversifier - invalid signature
-- DEP with no matching DRKi (Only DEP or only DRKi with diversifier)


## PTC_5079_1: SignedDirectEncryptedPseudonym with 1 DiversifierKeyValuePair - invalid signed

tags: @bsnkeiddo-5060@

U key content is invalid
* Create OASSignedDirectEncryptedPseudonymRequest 

   |propertyName                  |propertyValue                                       |propertyFilter        |
   |------------------------------|----------------------------------------------------|----------------------|
   |signedDirectEncryptedPseudonym|{{ PTC_5079_1.request.signedDirectEncryptedPseudonym|binary              }}|
   |schemeKeys                    |{{ PTC_5079_1.request.schemeKeys                    |schemeKeys          }}|
   |serviceProviderKeys           |{{ PTC_5079_1.request.serviceProviderKeys           |serviceProviderKeys }}|
   |targetClosingKey              |{{ PTC_5079_1.request.targetClosingKey              |string              }}|
   |authorizedParty               |{{ PTC_5079_1.request.authorizedParty               |string              }}|
* Send OASSignedDirectEncryptedPseudonymRequest
* Expect response matches 

   |actualValue|expectedValue                        |expectedValueType |
   |-----------|-------------------------------------|------------------|
   |statusCode |{{ PTC_5079_1.expectations.statusCode|string          }}|
* Expect response body contains "SIGNATURE_VERIFICATION_FAILED"
* Fail if expectations are not met

## PTC_5079_2: SignedDirectEncryptedPseudonym with 2 DiversifierKeyValuePairs - invalid signed

tags: @bsnkeiddo-5061@

U key content is invalid
* Create OASSignedDirectEncryptedPseudonymRequest 

   |propertyName                  |propertyValue                                       |propertyFilter        |
   |------------------------------|----------------------------------------------------|----------------------|
   |signedDirectEncryptedPseudonym|{{ PTC_5079_2.request.signedDirectEncryptedPseudonym|binary              }}|
   |schemeKeys                    |{{ PTC_5079_2.request.schemeKeys                    |schemeKeys          }}|
   |serviceProviderKeys           |{{ PTC_5079_2.request.serviceProviderKeys           |serviceProviderKeys }}|
   |targetClosingKey              |{{ PTC_5079_2.request.targetClosingKey              |string              }}|
   |authorizedParty               |{{ PTC_5079_2.request.authorizedParty               |string              }}|
* Send OASSignedDirectEncryptedPseudonymRequest
* Expect response matches 

   |actualValue|expectedValue                        |expectedValueType |
   |-----------|-------------------------------------|------------------|
   |statusCode |{{ PTC_5079_2.expectations.statusCode|string          }}|
* Expect response body contains "SIGNATURE_VERIFICATION_FAILED"
* Fail if expectations are not met

## PTC_5079_3: SignedDire  ctEncryptedPseudonym with 3 DiversifierKeyValuePairs - invalid signed

tags: @bsnkeiddo-5062@

U key content is invalid
* Create OASSignedDirectEncryptedPseudonymRequest 

   |propertyName                  |propertyValue                                       |propertyFilter        |
   |------------------------------|----------------------------------------------------|----------------------|
   |signedDirectEncryptedPseudonym|{{ PTC_5079_3.request.signedDirectEncryptedPseudonym|binary              }}|
   |schemeKeys                    |{{ PTC_5079_3.request.schemeKeys                    |schemeKeys          }}|
   |serviceProviderKeys           |{{ PTC_5079_3.request.serviceProviderKeys           |serviceProviderKeys }}|
   |targetClosingKey              |{{ PTC_5079_3.request.targetClosingKey              |string              }}|
   |authorizedParty               |{{ PTC_5079_3.request.authorizedParty               |string              }}|
* Send OASSignedDirectEncryptedPseudonymRequest
* Expect response matches 

   |actualValue|expectedValue                        |expectedValueType |
   |-----------|-------------------------------------|------------------|
   |statusCode |{{ PTC_5079_3.expectations.statusCode|string          }}|
* Expect response body contains "SIGNATURE_VERIFICATION_FAILED"
* Fail if expectations are not met

## PTC_5079_4: SignedDirectEncryptedPseudonym - DEP contains diversifier, DRKi has no diversifier

tags: @bsnkeiddo-5063@

* Create OASSignedDirectEncryptedPseudonymRequest 

   |propertyName                  |propertyValue                                       |propertyFilter        |
   |------------------------------|----------------------------------------------------|----------------------|
   |signedDirectEncryptedPseudonym|{{ PTC_5079_4.request.signedDirectEncryptedPseudonym|binary              }}|
   |schemeKeys                    |{{ PTC_5079_4.request.schemeKeys                    |schemeKeys          }}|
   |serviceProviderKeys           |{{ PTC_5079_4.request.serviceProviderKeys           |serviceProviderKeys }}|
   |targetClosingKey              |{{ PTC_5079_4.request.targetClosingKey              |string              }}|
   |authorizedParty               |{{ PTC_5079_4.request.authorizedParty               |string              }}|
* Send OASSignedDirectEncryptedPseudonymRequest
* Expect response matches 

   |actualValue|expectedValue                        |expectedValueType |
   |-----------|-------------------------------------|------------------|
   |statusCode |{{ PTC_5079_4.expectations.statusCode|string          }}|
* Expect response body contains "MATCHING_DIRECT_RECEIVE_KEY_REQUIRED"
* Fail if expectations are not met

## PTC_5079_5: SignedDirectEncryptedPseudonym - DRKi contains diversifier, DEP has no diversifier

tags: @bsnkeiddo-5064@

* Create OASSignedDirectEncryptedPseudonymRequest 

   |propertyName                  |propertyValue                                       |propertyFilter        |
   |------------------------------|----------------------------------------------------|----------------------|
   |signedDirectEncryptedPseudonym|{{ PTC_5079_5.request.signedDirectEncryptedPseudonym|binary              }}|
   |schemeKeys                    |{{ PTC_5079_5.request.schemeKeys                    |schemeKeys          }}|
   |serviceProviderKeys           |{{ PTC_5079_5.request.serviceProviderKeys           |serviceProviderKeys }}|
   |targetClosingKey              |{{ PTC_5079_5.request.targetClosingKey              |string              }}|
   |authorizedParty               |{{ PTC_5079_5.request.authorizedParty               |string              }}|
* Send OASSignedDirectEncryptedPseudonymRequest
* Expect response matches 

   |actualValue|expectedValue                        |expectedValueType |
   |-----------|-------------------------------------|------------------|
   |statusCode |{{ PTC_5079_5.expectations.statusCode|string          }}|
* Expect response body contains "MATCHING_DIRECT_RECEIVE_KEY_REQUIRED"
* Fail if expectations are not met

## PTC_5079_6: SignedDirectEncryptedPseudonym - DRKi contains diversifier different from DEP

tags: @bsnkeiddo-5065@

Diversifier in SDEP is different from DRKi diversifier
* Create OASSignedDirectEncryptedPseudonymRequest 

   |propertyName                  |propertyValue                                       |propertyFilter        |
   |------------------------------|----------------------------------------------------|----------------------|
   |signedDirectEncryptedPseudonym|{{ PTC_5079_6.request.signedDirectEncryptedPseudonym|binary              }}|
   |schemeKeys                    |{{ PTC_5079_6.request.schemeKeys                    |schemeKeys          }}|
   |serviceProviderKeys           |{{ PTC_5079_6.request.serviceProviderKeys           |serviceProviderKeys }}|
   |targetClosingKey              |{{ PTC_5079_6.request.targetClosingKey              |string              }}|
   |authorizedParty               |{{ PTC_5079_6.request.authorizedParty               |string              }}|
* Send OASSignedDirectEncryptedPseudonymRequest
* Expect response matches 

   |actualValue|expectedValue                        |expectedValueType |
   |-----------|-------------------------------------|------------------|
   |statusCode |{{ PTC_5079_6.expectations.statusCode|string          }}|
* Expect response body contains "MATCHING_DIRECT_RECEIVE_KEY_REQUIRED"
* Fail if expectations are not met
